
;Fastcopy + Horizontal + Vertical Scrolling Tilemap by Dwedit
;
;Input:
;  de = plotsscreen
;  (mapAdress) = word,Base address of map
;  (viewY) = word,vertical location of camera
;  (viewX) = word,horizontal location of camera
;  (tilesAdress) = word,pointer to tileset
;  tilesbuf = label,destructable tileset buffer equal in size to the tileset
;  tilesbuf2 = label,another destructable tileset buffer, also equal in size to the tileset
;  NUM_TILES = byte constant,number of tiles in the tileset (size of tileset/8)
;  (mapWidth) = word,width of tilemap
;Output:
;  screen copied from buffer to screen
;  tilemap drawn on buffer, with origin (viewX,viewY)
;
;Needs modification, change where it multiplies hl by map width (currently fixed at 12)

FastCopyTilemap:
 ld hl,frameCounter
 inc (hl)

 di
 ld a,$80
 out ($10),a ;set row 0
 push de
  ;Get new mapAdress and x-tile scroll from viewX
   ld hl,(viewX)
   call convHLtoPixels
   call DivBy8Common
   ld bc,(mapAdress)
   add hl,bc
   push hl
     call MessUpTiles
    ;Now get yscroll and adjust basemap for viewY
     ld hl,(viewY)
     call convHLtoPixels
     call DivBy8Common
     ld (TM_ModYpos+1),a

    ;Multiply HL by map width here
	call HLtimesMapWidth

   pop bc
   add hl,bc
   push hl
    ;RenderTileModder:
     add a,a
     add a,a
     ld c,a
     add a,a
     add a,c
     ld b,0
     ld c,a
     ld hl,RenderTile
     push hl
       add hl,bc
       ld (TM_Mod1+1),hl
     pop hl
     ld a,c
     cpl
     add a,97
     ld c,a
     add hl,bc
     ld (TM_Mod2+1),hl
   pop hl
 pop de
 xor a
TileMapLoop1:
 push af
  push hl \ push de;save base coordinates
   add a,$20    ;$20 + C = set column
   out ($10),a ;set column
   
  ;Draw top tile (clipped)
   push hl
     ld bc,TilesBuf2
     ld a,(hl)
     inc hl
     ld l,(hl)
     ld h,0
     add hl,hl
     add hl,hl
     add hl,hl
     add hl,bc
     push hl
     pop ix
     ld l,a
     ld h,0
     add hl,hl
     add hl,hl
     add hl,hl
     ld bc,TilesBuf
     add hl,bc
TM_ModYpos:
     ld bc,0000
     add hl,bc
     add ix,bc
     
     ex de,hl
     ld bc,12
TM_Mod1:
     call 0
   pop hl
   ld bc,(mapWidth)
   add hl,bc ;advance tile pointer by map's width
   
  ;Draw next 7 tiles
   ld b,7      ;8 tiles per column
TileMapLoop2:
   push bc
     push hl    ;save position on map
       ld bc,tilesBuf2
       ld a,(hl)
       inc hl
       ld l,(hl)
       ld h,0
       add hl,hl
       add hl,hl
       add hl,hl
       add hl,bc
       push hl
       pop ix
       ld l,a
       ld h,0
       add hl,hl
       add hl,hl
       add hl,hl
       ld bc,tilesBuf
       add hl,bc

       ex de,hl
       ld bc,12
       call RenderTile
     pop hl
     ld bc,(mapWidth)
     add hl,bc ;advance tile pointer by map's width
   pop bc
   djnz TileMapLoop2
   
  ;Draw bottom tile (clipped)
   ld bc,tilesBuf2
   ld a,(hl)
   inc hl
   ld l,(hl)
   ld h,0
   add hl,hl
   add hl,hl
   add hl,hl
   add hl,bc
   push hl
   pop ix
   ld l,a
   ld h,0
   add hl,hl
   add hl,hl
   add hl,hl
   ld bc,tilesBuf
   add hl,bc
   
   ex de,hl
   ld bc,12
TM_Mod2:
   call 0
DontRenderLastTile:
  pop de \ pop hl ;back to the top
  inc hl \ inc de ;next column for map and screen
 pop af
 inc a ;next column
;  ld a,c
 cp 12 ;stop after 12 columns  (maybe replace this if you need a smaller map)
 jp c,TileMapLoop1
 ret ;Done

RenderTile:
 ld a,(hl)    ;Write old byte to LCD
 out ($11),a
 ld a,(de)    ;read graphics data
 or (ix+0)
 ld (hl),a
 inc de
 inc ix
 add hl,bc
 ld a,(hl)    ;Write old byte to LCD
 out ($11),a
 ld a,(de)    ;read graphics data
 or (ix+0)
 ld (hl),a
 inc de
 inc ix
 add hl,bc
 ld a,(hl)    ;Write old byte to LCD
 out ($11),a
 ld a,(de)    ;read graphics data
 or (ix+0)
 ld (hl),a
 inc de
 inc ix
 add hl,bc
 ld a,(hl)    ;Write old byte to LCD
 out ($11),a
 ld a,(de)    ;read graphics data
 or (ix+0)
 ld (hl),a
 inc de
 inc ix
 add hl,bc
 ld a,(hl)    ;Write old byte to LCD
 out ($11),a
 ld a,(de)    ;read graphics data
 or (ix+0)
 ld (hl),a
 inc de
 inc ix
 add hl,bc
 ld a,(hl)    ;Write old byte to LCD
 out ($11),a
 ld a,(de)    ;read graphics data
 or (ix+0)
 ld (hl),a
 inc de
 inc ix
 add hl,bc
 ld a,(hl)    ;Write old byte to LCD
 out ($11),a
 ld a,(de)    ;read graphics data
 or (ix+0)
 ld (hl),a
 inc de
 inc ix
 add hl,bc
 ld a,(hl)    ;Write old byte to LCD
 out ($11),a
 ld a,(de)    ;read graphics data
 or (ix+0)
 ld (hl),a
 inc de
 inc ix
 add hl,bc
 ex de,hl
 ret

DivBy8Common:
 ld a,l
 sra h
 rra
 sra h
 rra
 sra h
 rra
 ld c,l
 ld l,a
 ld a,c
 and 7
 ret  

MessUpTiles: ;input: a=x pixel position
 cpl
 add a,8
MessUpTiles2:
 ld (MessUpTilesModify+1),a
 ld hl,InvertedMaskTable
 ld b,0
 ld c,a
 add hl,bc
 ld a,(hl)
 ld (MessUpTilesMask1+1),a
 cpl
 ld (MessUpTilesMask2+1),a
 ld hl,(tilesAdress)
 ld de,TilesBuf
 ld ix,TilesBuf2
 ld bc,8*NUM_TILES
MessUpTilesLoop:
 ld a,(hl)
MessUpTilesModify:
 jr $+2
 rlca
 rlca
 rlca
 rlca
 rlca
 rlca
 rlca
 ld (de),a
MessUpTilesMask2:
 and 0
 ld (ix+0),a
 ld a,(de)
MessUpTilesMask1:
 and 0
 ld (de),a
 inc de
 inc ix
 cpi
 jp pe,MessUpTilesLoop
 ret

InvertedMaskTable: ;stick this wherever you like
 .db %10000000
 .db %11000000
 .db %11100000
 .db %11110000
 .db %11111000
 .db %11111100
 .db %11111110
 .db %11111111
 

; The Best Damn Sprite Routine Period (Mask Version)
; 
; AUTHOR: Sean McLaughlin (sigma_zk@yahoo.com)
;
; DESCRIPTION:
;	Masks a sprite to PlotSScreen with clipping.
;
; INPUT:
;	D	Abscissa
;	E	Ordinate
;	HL	Pointer to start of sprite data:
;		number of rows; sprite row 1, mask row 1; sprite row 2, mask row 2; et cetera.
; DESTROYS:
;	AF BC DE HL IX
;	Interrupts are disabled
;
#define	M_PIXEL_SHIFT	.DB $CB,$31,$17,$29	; SLL C\  RLA\  ADD HL,HL

ClipSprite_MASK_aisheight:
	;version with A given
	ld b,a
	dec hl
	jr skp

ClipSprite_MASK:
	LD	B,(HL)
skp:	LD	A,E

	SUB	B   ;
	INC	A   ;hAcK
	LD	E,A ;

	CP	$80
	JR	C,_PosY
	NEG
	CP	B
	RET	P
	LD	C,A
	NEG
	ADD	A,B
	LD	B,0
	SLA	C
	ADD	HL,BC
	LD	E,B
	LD	B,A
_PosY:
	CP	64
	RET	NC
_ClipBtm:
	ADD	A,B
	SUB	65
	JR	C,_DoHoriz
	SUB	B
	CPL
	LD	B,A
_DoHoriz:
	LD	A,D
	CP	$80
	JR	C,_PosX
	CP	-7
	RET	C
	LD	IX,_ClipLeft
	JR	_Patch
_PosX:
	CP	96
	RET	NC
	CP	89
	LD	IX,_ClipRight
	JR	C,_DoSprite
_Patch:
	LD	(IX),0
_DoSprite:
	DI
	INC	HL
	LD	(_save),SP
	LD	SP,HL
	SLA	E
	SLA	E
	LD	L,E
	LD	H,0
	LD	D,H
	ADD	HL,HL
	ADD	HL,DE
	LD	E,A
	SRA	E
	SRA	E
	SRA	E
	JP	P,_Pos
	DEC	D
_Pos:
	ADD	HL,DE
	LD	DE,PlotSScreen
	ADD	HL,DE

	AND	7
	JR	Z,_Aligned
	DEC	A
	ADD	A,A
	ADD	A,A
	LD	(_Jump),A

_Loop:
	POP	DE
	XOR	A
	LD	C,D
	LD	D,A
	DEC	A
	EX	DE,HL
_Jump	=$+1
	JR	$
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	M_PIXEL_SHIFT
	EX	DE,HL
	AND	(HL)
	XOR	D
_ClipLeft:
	LD	(HL),A
	INC	HL
	LD	A,C
	AND	(HL)
	XOR	E
_ClipRight:
	LD	(HL),A
	LD	DE,11
	ADD	HL,DE
	DJNZ	_Loop
	LD	(IX),$77
_Done:
_save	=$+1
	LD	SP,0
	RET

_Aligned:
	LD	DE,12
	LD	A,B
_ALoop:
	POP	BC
	EX	AF,AF'
	LD	A,(HL)
	AND	B
	XOR	C
	LD	(HL),A
	ADD	HL,DE
	EX	AF,AF'
	DEC	A
	JP	NZ,_ALoop
	JP	_Done


;-----> Copy the gbuf to the screen (fast)
;Input:	nothing
;Output:graph buffer is copied to the screen
fastcopy:
	di
	ld	a,$80				; 7
	out	($10),a				; 11
	ld	hl,gbuf-12-(-(12*64)+1)		; 10
	ld	a,$20				; 7
	ld	c,a				; 4
	inc	hl				; 6 waste
	dec	hl				; 6 waste
fastCopyAgain:
	ld	b,64				; 7
	inc	c				; 4
	ld	de,-(12*64)+1			; 10
	out	($10),a				; 11
	add	hl,de				; 11
	ld	de,10				; 10
fastCopyLoop:
	add	hl,de				; 11
	inc	hl				; 6 waste
	inc	hl				; 6 waste
	inc	de				; 6
	ld	a,(hl)				; 7
	out	($11),a				; 11
	dec	de				; 6
	djnz	fastCopyLoop			; 13/8
	ld	a,c				; 4
	cp	$2B+1				; 7
	jr	nz,fastCopyAgain		; 10/1
	ret					; 10




