;==========================================================
; mapPrepareColumn(a=x)
;==========================================================
;converts special tiles in column to objects
mapPrepareColumn:
	ld d,0
	ld e,a
	ld hl,(mapAdress)
	add hl,de

	ld d,a ;X
	ld e,0 ;Y

	ld a,(screenHeight)
	ld b,a ;(screenHeight-Y)
mapPrepare_loop:
	push bc
	push de
	push hl
	ld a,(hl)
	call checkNumber
	pop hl
	ld de,(mapWidth)
	add hl,de
	pop de
	inc e
	pop bc
	djnz mapPrepare_loop
	
	;==check objectmem
	ld hl,objectmem
comlp:	ld a,(hl)
	cp 255 \ jr z,comnd
	cp d   \ jr nz,comnx
	or a   \ jr z,comnx
	push hl
	inc hl
	ld e,(hl)
	inc hl
	ld a,(hl)
	ld h,d
	ld l,e
	;push af
	call mapGetLoc
	;pop af
	call checkNumber
	pop hl
	ld (hl),0
	inc hl
	ld (hl),0
	inc hl
	ld (hl),0
	jr comlp

comnx:	inc hl
	inc hl
	inc hl
	jp comlp

comnd:
	ret

;--------------
;checkNumber
;--------------
;check a number
; A  = number on map
; HL = loc on map
; DE = coords on map
checkNumber:
	cp 100 \ jp c,checkNumber_end
	cp 101 \ call z,mapPrepare_qblock_MagicMushroom
	cp 110 \ jr z,mapPrepare_goomba
	cp 111 \ jr z,mapPrepare_koopatroopa
checkNumber_end:
	ret

;--------------
;100
;--------------
	jr checkNumber_end

 .db "heyaheya"


;--------------
;101 Magic Mushroom
;--------------
mapPrepare_qblock_MagicMushroom:
	ld (hl),QBOX_TILE
	call powerblock_insert
	jr checkNumber_end

;--------------
;110 Goomba
;--------------
mapPrepare_goomba:
	ld (hl),0
	call objectFindFreeSpot
	jr c, checkNumber_end
	;ld hl,dataObjects+32
	ld (hl),GOOMBA ;3

	ld b,GOOMBASPEED
	ld a,(dataObjects+xspeed)
	or a \ jp m, mpgnl
	ld b,-GOOMBASPEED
	ld c,0
mpgnl:  call setVillain
	ld (hl),110    ;origtile
	jp checkNumber_end

;--------------
;111 Koopa Troopa
;--------------
mapPrepare_koopatroopa:
	ld (hl),0
	call objectFindFreeSpot
       	jr c, checkNumber_end
	ld (hl),KOOPA_TROOPA

	ld b,-KOOPATROOPASPEED
	ld a,(dataObjects+xspeed)
	or a \ jp m, mptnl
	ld b,KOOPATROOPASPEED
mptnl:  ld c,0
	call setVillain
	ld (hl),111    ;origtile
	jp checkNumber_end

;==========================================================
; mapAnimateTiles
;==========================================================
; animates the tiles
mapAnimateTiles:
	;animate once in 4 frames
	ld a,(frameCounter)
	rra \ ret c
	rra \ ret c
	and %00000011
	ld c,a
	
	ld hl,(viewY+1)
	call HLtimesMapWidth
	ld de,(mapAdress)
	add hl,de
	ld a,(viewX+1)
	ld d,0
	ld e,a
	add hl,de

	;ld hl,(viewX)
	;ld a,(viewY+1)
	;ld l,a
	;call mapGetLoc

	ld b,9
	ld a,(viewY)
	or a \ jr nz,Y_notaligned
	dec b
Y_notaligned:

y_loop:	push bc
	push hl
	push hl
	pop de
	ld b,13
x_loop: push bc

	ld a,(de)

	ld hl,Tile_Animations
	ld b,(hl)
mat_loop:
	inc hl
	cp (hl) \ jr c,mat_next
	inc hl
	cp (hl) \ jr nc,mat_next2

	dec hl
	ld a,(hl)
	add a,c
	inc hl

mat_noreset:
	ld (de),a

mat_next:
	inc hl
mat_next2:
	djnz mat_loop

	inc de
	pop bc
	djnz x_loop

	pop de
	ld hl,(mapWidth)
	add hl,de
	pop bc
	djnz y_loop

	ret



;==========================================================
; mapGetTile(h=x,l=y)
;==========================================================
;output: a  = value of (h,l) on map
;        hl = location
; 	 de = x:y
;destroys c, de
mapGetTile:
	call mapGetLoc
	ld a,(hl)
	ret

mapGetLoc:
	push hl
	ld c,h
	ld h,0
	call HLtimesMapWidth
	ld d,0
	ld e,c
	add hl,de
	ld de,(mapAdress)
	add hl,de
	pop de
	ret


