

;=== convHLtoPixels
; INPUT: HL
; converts the detailed coord in HL to pixels coord
; hl = (BBBBBBBB BBB.BBBBB) -> (BBB BBBBBBBB.)
convHLtoPixels:
	push de
	ld d,h
	ld e,l
	srl d
	rr e
	srl d
	rr e
	srl d
	rr e
	srl d
	rr e
	srl d
	rr e
	ld h,d
	ld l,e
	pop de
	ret

;=== aTimes16
; INPUT: A
; OUTPUT: DE=12*A
; destroys de, hl
aTimes16:
	ld h,0 \ ld l,a
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	ex de,hl
	ret

;=== HLcheckbiggerBC
; INPUT: HL, BC
; OUTPUT: zero if bigger
; DESTROYS: A, BC
; checks if HL is bigger then BC,
; if its bigger then return Z else NZ
HLcheckbiggerBC:
	push hl
	or a
	sbc hl,bc
	ld a,h
	cp $F0 \ jr nc,HLcbBC_notbigger
	pop hl
	or 1
	ret
HLcbBC_notbigger:
	pop hl
	and 0
	ret

;=== cphlde
; compare hl with de
cphlde:
	push hl
	or a
	sbc hl,de
	pop hl
	ret

;=== negHL
; negates HL
negHL:
	ld a,h
	cpl
	ld h,a
	ld a,l
	cpl
	ld l,a
	ret

;=== absHL
; calculates absolute value of speed in HL
absHL:
	bit 7,h \ ret z	;zero if positive
	call

;=== invA
; inverse of B
invA:	cpl
	inc a
	ret

;=== HLtimesMapWidth
HLtimesMapWidth:
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl ;*128 (=mapWidth)
	ret








