
;==========================================================
; objectsDecideAll()
;==========================================================
;decides for each object the next move
objectsDecideAll:
	ret

;==========================================================
; objectsUpdateAll()
;==========================================================
;updates the speeds of the objects
objectsUpdateAll:
	ld b,20
	ld de,16
	ld hl,dataObjects
objectsUpdateAll_loop:
	push bc
	push de
	push hl
	ld a,(hl)
	or a \ call nz, objectUpdate
	pop hl
	pop de
	add hl,de
	pop bc
	djnz objectsUpdateAll_loop
	ret

;==========================================================
; objectUpdate(hl=object adress)
;==========================================================
objectUpdate:
	push hl
	pop ix

	ld a,(ix+sort)
	;conditional jumps come here
	;cp GOOMBA \ jr z,update_goomba
	cp MARIO	\ jr z,update_mario
	cp MARIOHEAD	\ jr z,update_mariohead
	cp JUMPY_TILE 	\ jr z,update_jumpytile
	cp JUMPY_COIN   \ jr z,update_jumpycoin
	cp GOOMBA_CORPSE \ jp z,update_goombacorpse
	cp MAGIC_MUSHROOM \ jp z,update_magicmushroom
	call addGravity
	ret

	.db "heliheli"

update_mario:
	call addgravity

	ld hl,playerUntouchable
	ld a,(hl)
	or a \ jr z, update_mario_2
	dec a
	ld (hl),a
update_mario_2:

	ld hl,(marioEdgeDetect)
	ld de,0
	ld (marioEdgeDetect),de
	call mapGetTile
	inc hl
	cp GOOD_TILES \ jr nc, update_mario_slideright
	ld a,(hl)
	cp GOOD_TILES \ ret c
	ld hl,dataObjects+x0
	ld a,(hl)
	cp %00100000
	ret nc
	ld (hl),0
	ret
update_mario_slideright:
	ld a,(hl)
	cp GOOD_TILES \ ret nc
	ld a,(dataObjects+xspeed)
	or a \ ret m
	ld hl,dataObjects+x0
	ld a,(hl)
	cp %11100000
	ret c
	ld (hl),0
	ld hl,dataObjects+x1
	inc (hl)
	ret

update_mariohead:
	;ld ix,dataObjects
	;ld a,(ix+xspeed)
	;ld (ix+16+xspeed),a
	;ld a,(ix+yspeed)
	;ld (ix+16+yspeed),a

	call marioHeadFollowBody_X
	call marioHeadFollowBody_Y
	ret

update_jumpytile:
	dec (ix+state)
	ret nz
	;remove it
	call objectVanish
	ret

update_jumpycoin:
	dec (ix+state)
	jp z,objectVanish
	ld a,(ix+state)
	cp 9 \ jr c,update_jumpycoin_gravity
	ld (ix+yspeed),-128
	ret
update_jumpycoin_gravity:
	call addgravity
	call addgravity
	ret

update_goombacorpse:
	dec (ix+state)
	ret nz
	call objectVanish
	ret

	.db "ritsrits"

update_magicmushroom:
	ld a,(ix+state)
	or a \ jr nz,update_magicmushroom_growing
	call addGravity
	ret
update_magicmushroom_growing:
	dec a
	ld (ix+state),a
	ret nz
	ld b,MUSHROOMSPEED
	ld a,(dataObjects+xspeed)
	or a \ jp p, aewir
	ld b,-MUSHROOMSPEED
aewir:	ld (ix+xspeed),b
	ret

addGravity:
	;==Gravity
	;reminder:
	; drawloosebrick uses conditional output
	ld a,(ix+yspeed)
	add a,GRAVITY
	jp po, gr_noo
	ld a,127
gr_noo:	ld (ix+yspeed),a
	ret

;==========================================================
; objectsMoveAndCheckAll()
;==========================================================
;updates coords with speed
objectsMoveAndCheckAll:
	ld b,20
objectsMoveAndCheckAll_loop:
	push bc
	ld a,20
	sub b
	call objectMoveAndCheck
	pop bc
	djnz objectsMoveAndCheckAll_loop
	ret

;==========================================================
; objectMoveAndCheck(a=id)
;==========================================================
objectMoveAndCheck:
	call objectGetAdress

	ld a,(ix+yspeed)
	or a \ call nz, doYcheckY

       	ld a,(ix+xspeed)
	or a \ call nz, doXcheckX

	ret


doXcheckX:
	jp m, decreaseXcheckX
	jp increaseXcheckX
doYcheckY:
	jp m, decreaseYcheckY
	jp increaseYcheckY

;----------------------------------------------------------
; decreaseXcheckX
;----------------------------------------------------------
; input: a = xspeed
;	 ix = object index
decreaseXcheckX:
	;== MOVE
	ld h,(ix+x1)		;get X
	ld b,h
	ld l,(ix+x0)

	cpl
	inc a
	ld d,0
	ld e,a
	or a
	sbc hl,de

	ret c ;X<0

	ld (ix+x1),h		;save new X
	ld (ix+x0),l

	ld a,h
	cp b \ ret z	;stop when not changing tile

	;== CHECK LOWER LEFT PIXEL
	;ld h,(ix+x1)
	ld l,(ix+y1)
	call mapGetTile
	cp GOOD_TILES \ call nc, objectHitTile_left

	;== CHECK UPPER LEFT PIXEL
	ld h,e
	ld l,(ix+y0)

	inc hl ;-255
	dec h  ;

	ld l,h
	ld h,d
	call mapGetTile
	cp GOOD_TILES \ call nc, objectHitTile_left
	ret

;----------------------------------------------------------
; increaseXcheckX
;----------------------------------------------------------
; input: a = xspeed
;	 ix = object index
increaseXcheckX:
	;== MOVE
	ld h,(ix+x1)		;get X
	ld l,(ix+x0)
	dec hl
	ld b,h
	inc hl
	ld d,0
	ld e,a
	add hl,de
	ld (ix+x1),h		;save new X
	ld (ix+x0),l

	dec hl
	ld a,h
	cp b \ ret z

	;== CHECK LOWER RIGHT PIXEL
	;dec hl	;+255
	inc h   ;

        ld l,(ix+y1)
        ;push hl
        call mapGetTile
	cp GOOD_TILES \ call nc, objectHitTile_right

	;== CHECK UPPER RIGHT PIXEL
	;pop bc
	ld h,e
	ld l,(ix+y0)
	
	inc hl ;-255
	dec h  ;

	ld a,h
	cp e \ ret z

	ld l,h
	ld h,d
	call mapGetTile
	cp GOOD_TILES \ call nc, objectHitTile_right
	ret

;----------------------------------------------------------
; decreaseYcheckY
;----------------------------------------------------------
; input: a = yspeed
;	 ix = object index

	.db "hellhell"
decreaseYcheckY:
	;== MOVE
	ld h,(ix+y1)		;get Y
	ld l,(ix+y0)
	inc hl
	ld b,h
	dec hl
	cpl
	inc a
	ld d,0
	ld e,a
	or a
	sbc hl,de
	ret c ;Y<0

	ld (ix+y1),h		;save new Y
	ld (ix+y0),l

	inc hl
	ld a,h
	dec hl
	cp b \ ret z

	inc hl  ;
	dec h	;Y-255

	ld a,(ix+x0)
	or a
	jp m, right_left

left_right:
	;first check upper left, then upper right
	;== CHECK UPPER LEFT PIXEL
	ld l,h ;y-255
	ld h,(ix+x1)
	call mapGetTile
	cp GOOD_TILES \ call nc, objectHitTile_top

	;== CHECK UPPER RIGHT PIXEL
	ld h,d
	ld l,(ix+x0)
	dec hl 		;+255
	inc h           ;
	ld l,e

	call mapGetTile
	cp GOOD_TILES \ call nc, objectHitTile_top
	ret

right_left:
	;== CHECK UPPER RIGHT PIXEL
	ld e,h
	ld h,(ix+x1)
	ld l,(ix+x0)
	dec hl 		;+255
	inc h           ;
	ld l,e
	call mapGetTile
	cp GOOD_TILES \ call nc, objectHitTile_top

	;== CHECK UPPER LEFT PIXEL
	ld l,e ;y-255
	ld h,(ix+x1)
	call mapGetTile
	cp GOOD_TILES \ call nc, objectHitTile_top

	ret

;----------------------------------------------------------
; increaseYcheckY
;----------------------------------------------------------
; input: a = yspeed
;	 ix = object index
increaseYcheckY:
	;== MOVE
	ld h,(ix+y1)		;get Y
	ld b,h
	ld l,(ix+y0)
	ld d,0
	ld e,a
	add hl,de
	ld (ix+y1),h		;save new Y
	ld (ix+y0),l

	push hl
	push bc

	;== CHECK LOWER MIDDLE PIXEL (SLOPED SURFACES)
	ld c,h
	ld h,(ix+x1)
	ld l,(ix+x0)
	;ld d,0
	ld e,128	;X plus a half tile
	add hl,de
	ld l,c
	call mapGetTile
	and %11111000
	cp SLOPED_TILES \ jp z, objectHitTile_sloped

	pop bc
	pop hl
	ld a,h
	cp c \ ret z

	;== CHECK LOWER LEFT PIXEL
	ld l,h
	ld h,(ix+x1)

	call mapGetTile
	cp GOOD_TILES \ call nc, objectHitTile_bottom

	;== CHECK LOWER RIGHT PIXEL
       	ld h,d
	ld l,e
	ld l,(ix+x0)
	dec hl		;+255
	inc h

	ld l,(ix+y1)
	call mapGetTile
	cp GOOD_TILES \ call nc, objectHitTile_bottom
	ret

;----------------------------------------------------------
; objectHitTile_[left|right|top|bottom]
;----------------------------------------------------------
; INPUT: ix = object pointer
;	 hl = tile pointer
; OUTPUT: action with object

;----------------------------------------------------------
; left (de=tilecoords, hl=tileloc)
;----------------------------------------------------------
; de=tile's x,y
objectHitTile_left:
	ld a,(hl)
	and %11111100
	cp ONEWAY_PLATFORMS \ ret z	;1-way platforms
	cp COIN_TILE	\ jp z, left_coin

	ld (ix+x0),0
	inc (ix+x1)

	ld a,(ix+sort)
	cp MARIO \ jr z,left_mario
	cp MARIOHEAD \ jr z,left_mariohead
	cp GOOMBA \ jr z,left_invertspeed
	cp KOOPA_TROOPA \ jr z, left_invertspeed
	cp KOOPA_SHELL  \ jr z, left_koopashell
	cp MAGIC_MUSHROOM \ jr z, left_invertspeed

	;rest:
	ld (ix+xspeed),0	;reset xspeed

	pop bc \ ret

;---------------------
left_coin:
	ld a,(ix+sort)
	cp MARIO \ jp z, marioGetCoin
	cp MARIOHEAD \ jp z, marioGetCoin
	ret

;---------------------
left_mariohead:
	ld (ix+xspeed),0	;reset xspeed
	push ix
	push hl
        call marioBodyFollowHead_X
        pop hl
        pop ix
	jr left_mario

;---------------------
left_mario:
	ld a,(hl)
	and %11111100
	cp COIN_TILE	\ jp z, marioGetCoin
	ld (ix+xspeed),0	;reset xspeed
	push ix
        call marioHeadFollowBody_X
        pop ix
	pop bc \ ret
	.db "wortwort"

;---------------------
left_goomba:

;---------------------
left_koopatroopa:

;---------------------
left_koopashell:
	ld (ix+xspeed),KOOPASHELLSPEED
	jp right_koopashell_2

;---------------------
left_invertspeed:
	ld a, (ix+xspeed)
	cpl
	inc a
	ld (ix+xspeed),a
	pop bc \ ret

;----------------------------------------------------------
; right (de=tilecoords, hl=tileloc)
;----------------------------------------------------------
; de=tile's x,y
objectHitTile_right:
	ld a,(hl)
	and %11111100
	cp ONEWAY_PLATFORMS \ ret z	;1-way platforms
	cp COIN_TILE	\ jp z, left_coin

	ld (ix+x0),0

	ld a,(ix+sort)
	cp MARIO \ jr z,left_mario
	cp MARIOHEAD \ jr z,left_mariohead
	cp GOOMBA \ jr z,left_invertspeed
	cp KOOPA_TROOPA \ jr z, left_invertspeed
	cp KOOPA_SHELL  \ jr z, right_koopashell
	cp MAGIC_MUSHROOM \ jr z, left_invertspeed

        ld (ix+xspeed),0 ;rest

	ret

;---------------------
right_mario:

;---------------------
right_goomba:

;---------------------
right_koopatroopa:

;---------------------
right_koopashell:
	ld (ix+xspeed),-KOOPASHELLSPEED
right_koopashell_2:
	ld a,(hl)
	cp 51 \ jp z, righthit_brick
	and %11111100
	cp QBOX_TILE \ jr z, righthit_qbox
	ret

;==================
righthit_brick:
	call powerblock_check
	cp 255 \ jp z, tophit_brick_break
	ret

;==================
righthit_qbox:
	call powerblock_check
	cp 255 \ jp z,tophit_qbox_2
	ret


	.db "leftleft"

;----------------------------------------------------------
; top (de=tilecoords, hl=tileloc)
;----------------------------------------------------------
objectHitTile_top:
	;remember: save HL and DE for actions
	ld a,(hl)
	and %11111100
	cp ONEWAY_PLATFORMS \ ret z	;1-way platforms
	cp COIN_TILE	\ jp z, left_coin

	ld a,(ix+sort)
	cp MARIO \ jr z,top_mario
	cp MARIOHEAD \ jr z,top_mariohead

       	;ld (ix+yspeed),64
	;ld (ix+y0),255

	pop bc \ ret

;---------------------
top_mariohead:
	ld (ix+y0),255
	ld (ix+yspeed),64
	;push ix
	;push hl
	;push de
	;call marioBodyFollowHead_Y
	;pop de
	;pop hl
	;pop ix
	ld ix,dataObjects
	ld (ix+y0),255
	ld (ix+yspeed),64
	jr top_mario2

;---------------------
top_mario:
	ld (ix+y0),255
       	ld (ix+yspeed),64
top_mario2:
	ld a,(hl)
	cp 51 \ jr z,tophit_brick
	and %11111100
	cp QBOX_TILE \ jr z,tophit_qbox
	pop bc \ ret

;==================
tophit_brick:
	;call check_alignedness
	;ret nz
	call powerblock_check
	cp 255 \ ret nz
	;does this when no powertile action performed
	ld a,(dataObjects+16)
	or a \ jr nz,tophit_brick_break
tophit_brick_bump:
	call bumptile
	  ld (hl),1
	pop bc \ ret
tophit_brick_break:
	ld (hl),0

	ld ix,loosebrickmem
	ld c,-32
	call tophit_brick_makeloosebrick
	ld ix,loosebrickmem+12
	ld c,-128
	call tophit_brick_makeloosebrick
	pop bc \ ret

tophit_brick_makeloosebrick:
	ld (ix+0),1
	ld (ix+1),0
	ld (ix+2),d
	ld (ix+3),128
	ld (ix+4),e
	ld (ix+5),c

	ld (ix+7),0
	ld (ix+8),d
	ld (ix+9),128
	ld (ix+10),e
	ld (ix+11),c
	ret

	.db "slepslep"

;==================
tophit_qbox:
	;call check_alignedness
	;ret nz
	call powerblock_check
	cp 255 \ ret nz
tophit_qbox_2:
	push hl
	  call objectFindFreeSpot
	  ld (hl),JUMPY_COIN
	  ;its a coinbox
	  ld b,0
	  ld c,14
	  dec e
	  call setVillain
	  inc e
	pop hl

	ld (hl),50
	call bumptile
	  ld (hl),0
	pop bc \ ret


check_alignedness:
	;check alignedness
	push hl
	ld hl,(dataObjects+x0) ;marioX
	ld bc,64
	add hl,bc
	ld a,h
	pop hl
	cp d \ ret z
	push hl
	ld bc,192
	add hl,bc
	ld a,h
	pop hl
	cp d \ ret z
	ret

;----------------------------------------------------------
; bottom (de=tilecoords, hl=tileloc)
;----------------------------------------------------------
; preserve DE in here
objectHitTile_bottom:
	ld a,(hl)
	and %11111100
	cp COIN_TILE	\ jp z, left_coin

	ld a,(ix+sort)
	cp MARIOHEAD \ ret z
	cp MARIO \ jr z,bottom_mario
	ld (ix+yspeed),0	;reset xspeed
	dec (ix+y1)
	ld (ix+y0),255
	ret

bottom_mario:
	ld (marioEdgeDetect),de
	ld a,(dataObjects+x1)
	ld (marioEdgeDetect+1),a

	ld (ix+yspeed),0	;reset xspeed
	dec (ix+y1)
	ld (ix+y0),255
        ;end of jump
	ld hl,playerInAir
	ld (hl),0
	call marioHeadFollowBody_Y
	ret

	.db "rotarota"

;----------------------------------------------------------
; sloped (de=tilecoords, hl=tileloc)
;----------------------------------------------------------
objectHitTile_sloped:
	pop bc
	pop bc

	ld a,(hl)
	cp SLOPED_TILES+0 \ jr z, sloped_0
	ret

sloped_0:
	ld a,(ix+x0)
	add a,128
	ld b,a

	ld a,(ix+y0)
	cpl
	inc a

	cp b
	ret nc

	ld a,b
	cpl
	inc a
	ld (ix+y0),a
	ret


;==========================================================
; objectsCollisionAll()
;==========================================================
; check inter-object collision
objectsCollisionAll:
	ld b,20
	ld de,16
	ld ix,dataObjects
objectsCollisionAll_loop:
	push bc
	push de
	ld a,(ix)
	cp 1 \ call z, col_mario
	cp 2 \ call z, col_mario
	pop de
	add ix,de
	pop bc
	djnz objectsCollisionAll_loop
	ret

;==========================================================
; ObjectCollision(ix=object)
;==========================================================

	;mario collides with everything but himself
col_mario:

	ld hl,dataObjects+32
	ld b,18
cm_loop:
	push ix
	push bc
	push hl

	ld a,(hl)
	or a \ jr z,cm_next

	inc hl	\ ld e,(hl)
	inc hl  \ ld d,(hl)
	ld b,(ix+x1) ;mario X
	ld c,(ix+x0) ;mario X
	call checkCollision
	jr nc, cm_next

	inc hl	\ ld e,(hl) ;REMINDER: DE ALSO NEEDED IN FUTURE
	inc hl  \ ld d,(hl)
	ld b,(ix+y1) ;mario Y
	ld c,(ix+y0) ;mario Y
	call checkCollision ;b<ontopof
	jr nc, cm_next

	dec hl \ dec hl \ dec hl \ dec hl
	ld a,(hl)
	cp GOOMBA 	\ jr z,col_mario_goomba
	cp KOOPA_TROOPA \ jr z,col_mario_koopatroopa
	cp KOOPA_SHELL	\ jp z,col_mario_koopashell
	cp MAGIC_MUSHROOM \ jp z,col_mario_magicmushroom
cm_next:
	pop hl
	ld bc,16
	add hl,bc
	pop bc
	pop ix
	djnz cm_loop
	
cm_end:
	ret

 .db "droldrol"

col_mario_goomba:
	call checkOnTop
	jr nz, col_mariohit

	;kill goomba!
	push hl
	call second_released_2
	call second_pressed_2
	xor a
	call objectMoveAndCheck
	pop ix
	ld (ix+sort), GOOMBA_CORPSE
	ld (ix+state), 15
	ld (ix+xspeed), 0
	ld (ix+origtile), 0
	jr cm_next

col_mario_koopatroopa:
	call checkOnTop
	jp nz, col_mariohit

col_mario_makeshell:
	push hl
	call second_released_2
	call second_pressed_2
	xor a
	call objectMoveAndCheck
	pop ix
	ld (ix+sort), KOOPA_SHELL
	ld (ix+state), 100
	ld (ix+xspeed), 0
	ld (ix+origtile), 0
	jr cm_next

col_mario_koopashell:
	ld bc,xspeed
	push hl
	add hl,bc
	ld a,(hl)
	pop hl
	or a \ jr z, col_mario_launchshell
	ld a,(playerUntouchable)
	or a \ jr nz, cm_next
	jr col_mario_koopatroopa

col_mario_launchshell:
	;==LAUNCH SHELL
	ld a,UNTOUCHABLE_TIME
	ld (playerUntouchable),a
	ld b, KOOPASHELLSPEED
	call checkLeftRight
	jr nz, shell_toright
	ld b, -KOOPASHELLSPEED
shell_toright:
	push hl
	pop ix
	ld (ix+xspeed),b
	ld a,(ix+objnr)
	;call objectMoveAndCheck

	jp cm_next

col_mario_magicmushroom:
	push hl
	pop ix
	call objectVanish
	call marioBecomeBig
	jp cm_next

col_mariohit:
	;ld a,(playerUntouchable)
	;or a \ jp nz, cm_next

       	ld a,(playerIsHit)
	or a \ jp nz, cm_next

	call marioBecomeSmall
	jp cm_next


	.db "checktop"

;----------------------------------------------------------
; checkLeftRight( de, ix)
;----------------------------------------------------------
; check relative position DE from IX
; OUTPUT:  NZ if IX >  DE
;          Z  if DE >= IX
checkLeftRight:
	push hl
	inc hl \ ld e,(hl)
	inc hl \ ld d,(hl)
	ld h,(ix+x1)
	ld l,(ix+x0)
	or a
	sbc hl,de
	bit 7,h
	pop hl
	ret

;----------------------------------------------------------
; checkOnTop(de, ix)
;----------------------------------------------------------
; checks weither Y(IX) < Y(DE)-128
; OUTPUT:   NZ  if not on top
; 	    Z   if on top
; DESTROYS: DE
checkOnTop:
	push hl
	push de
	pop hl
	ld de,KILLHEIGHT
	or a
	sbc hl,de
	ld d,(ix+y1)
	ld e,(ix+y0)
	or a
	sbc hl,de
	bit 7,h
	pop hl
	ret

;----------------------------------------------------------
; checkCollision(bc=coord1, de=coord2)
;----------------------------------------------------------
; NC if no hit
checkCollision:
	ld a,d
	inc a
	cp b \ jr z,cc_minus1
	dec a
	cp b \ jr z,cc_same
	dec a
	cp b \ jr z,cc_plus1
	or a
	ret

cc_minus1:
	ld a,c
	sub e
	ret

cc_same:
	ccf
	ret

cc_plus1:
	ld a,e
	sub c
	ret

;==========================================================
; objectVanish(ix=object)
;==========================================================
; removes object and maybe
objectVanish:
	push ix
	ld a,(ix+origtile)
	or a \ jr z, objectVanish_dontsettile

	ld a,(viewX+1)
	ld b,a
	ld a,(ix+origx)
	sub b
	cp 13 \ jp nc,settile

	;search for free objectmem spot
	ld hl,objectmem
omlp:	ld a,(hl)
	or a \ jr z, omct
	cp 255 \ jr z, objectVanish_dontsettile
	inc hl \ inc hl \ inc hl
	jr omlp

	;set objectmem spot
omct:	ld a,(ix+origx)
	ld (hl),a
	inc hl
	ld a,(ix+origy)
	ld (hl),a
	inc hl
	ld a,(ix+origtile)
	ld (hl),a
	jr objectVanish_dontsettile

settile:
	;== set tile to enemy
	ld h,(ix+origx)
	ld l,(ix+origy)
	call mapGetTile
	ld a,(ix+origtile)
	ld (hl),a

objectVanish_dontsettile:
	;== clear object info
	push ix
	pop hl
	call objectKillHL
	pop ix
	ret

;----------------------------------------------------------
; objectKillHL(hl=object)
;----------------------------------------------------------
objectKillHL:
	ld d,h
	ld e,l
	inc de
	ld (hl),0
	ld bc,14
	ldir
	ret

;==========================================================
; objectGetScreenPos(ix=object)
;==========================================================
;OUTPUT: DE=coordinates
objectGetScreenPos:
	ld h,(ix+y1)
	ld l,(ix+y0)
	ld de,(viewY)
	or a
	sbc hl,de
	call convHLtoPixels
	push hl

	ld h,(ix+x1)
	ld l,(ix+x0)
	ld de,(viewX)
	or a
	sbc hl,de
	call convHLtoPixels
	pop de

	ld d,l
	ret

;==========================================================
; objectGetState(a=id)
; output: a=state
;==========================================================
;objectGetState:
	call objectGetAdress
	ld a,(ix+13)
	ret

;==========================================================
; objectGetAdress(a=id)
; output: ix=adress
; destroys de
;==========================================================
objectGetAdress:
	push af
	call aTimes16
	ld ix,dataObjects
	add ix,de
	pop af
	ret	

;==========================================================
; objectFindFreeSpot
;==========================================================
; finds free spot in dataObjects
; OUTPUT: carry set means failure
;	  HL = adress
;         a = # spot
; DESTROYS: HL, B
objectFindFreeSpot:
	push de
	ld hl, dataObjects+32
	xor a
	ld b,18
	ld de,16
frslp:	cp (hl)
	jr z,frsdn
	add hl,de
	djnz frslp
	scf   ;when failed: set carry flag
	pop de
	ret
frsdn:
	ld a,20
	sub b
	pop de
	or a  ;reset carry flag
	ret

;==========================================================
; objectsResetAll
;==========================================================
objectsResetAll:
	ld hl,dataObjects
	ld b,20
objectsResetAll_loop:
	push bc
	call objectKillHL
	inc hl
	inc hl
	pop bc
	djnz objectsResetAll_loop
	ret

